<template>
    <div>
        <div id="main-center">
            <div id="form-header">Rejoindre la partie</div>
            <div id="container-page1">
                <div id="left-page1">
                    <div id="skin-gender-selector-container">
                        <button @click="maleSkins" id="btn-gender-male" title="Hommes" class="gender-selection">
                            <img id="male" class="gender-nonactive"
                                src="@/assets/images/form/male.svg"
                                alt="men_symbol"
                                width=16
                            >
                        </button>
                        <button @click="femaleSkins" id="btn-gender-female" title="Femmes" class="gender-selection">
                            <img id="female" class="gender-active"
                                src="@/assets/images/form/female.svg"
                                alt="men_symbol"
                                width=12
                            >
                        </button>
                    </div>
                    <div id="skin-selector-container">
                        <div id="skin-selector-header">Skin</div>
                        <div id="skin-selector-skin">
                            <div class="skin-selector-switch">
                                <div @click="previousSkin" id="btn-skin-previous" class="skin-circle-selector">&lt;</div>
                            </div>
                            <img id="skin-selector-preview" :src="currentSkin.path">
                            <div class="skin-selector-switch">
                                <div @click="nextSkin" id="btn-skin-next" class="skin-circle-selector">></div>
                            </div>
                        </div>
                        <div class="button-shop gratuit">Gratuit</div>
                    </div>
                </div>
                <div id="right-page1">
                    <div id="welcome-title">
                        <h1>Bienvenue</h1>
                        <h2>Change ton skin et rejoint la partie</h2>
                    </div>
                    <div id="input-pseudo">
                        <input v-model="username" id="inputPseudo" required autofocus maxlength=14 placeholder="Pseudo" type="text">
                    </div>
                    <div id="nav-bar-page1">
                        <div id="nav-bar-bottom">
                            <button @click="goToHomePage" id="btn-page1-home" class="nav-bar-button">Accueil</button>
                            <button @click="joinGame" id="btn-page1-next" class="nav-bar-button">Rejoindre</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {
    mapActions, mapGetters
} from 'vuex'

export default {
    data() {
        return {
            username: '',
            counter: 0,
            skinType: 'all',
        }
    },
    methods: {
        ...mapActions([
            'editMenu',
            'setSkins',
            'setCurrentSkin',
            'setCurrentUser'
        ]),
        maleSkins: function() {
            this.counter = 0;
            this.skinType = 'm';
            this.setCurrentSkin(this.getterMaleSkins[0])
        },
        femaleSkins: function() {
            this.counter = 0;
            this.skinType = 'f';
            this.setCurrentSkin(this.getterFemaleSkins[0])
        },
        previousSkin: function() {
            let skins = {};
            switch(this.skinType) {
                case 'm':
                    skins = this.getterMaleSkins
                    break;
                case 'f':
                    skins = this.getterFemaleSkins
                    break;
                default:
                    skins = this.skins
                    break;
            }
            const count = skins.length;
            this.counter++;
            if (this.counter >= count) {
                this.counter = 0
            }
            this.setCurrentSkin(skins[this.counter])
        },
        nextSkin: function() {
            let skins = {};
            switch(this.skinType) {
                case 'm':
                    skins = this.getterMaleSkins
                    break;
                case 'f':
                    skins = this.getterFemaleSkins
                    break;
                default:
                    skins = this.skins
                    break;
            }
            const count = skins.length;
            this.counter++;
            if (this.counter >= count) {
                this.counter = 0
            }
            this.setCurrentSkin(skins[this.counter])
        },
        joinGame: function() {
            const user = {
                username: this.username,
                skin: this.currentSkin
            }
            this.setCurrentUser(user)
            localStorage.removeItem('id')
            const idRoom = this.$route.params.id
            return this.$router.push({ name: 'room', params: { id: idRoom } })
        },
        goToHomePage: function() {
            return this.$router.push({ name: 'home' })
        }
    },
    computed: {
        ...mapGetters([
            'getSkins',
            'getMaleSkins',
            'getFemaleSkins',
            'getCurrentSkin'
        ]),
        skins() {
            return this.getSkins
        },
        getterFemaleSkins() {
            return this.getFemaleSkins
        },
        getterMaleSkins() {
            return this.getMaleSkins
        },
        currentSkin() {
            return this.getCurrentSkin
        }
    },
    mounted() {
        this.editMenu(false)
        this.setSkins();
    }
}
</script>

<style scoped>
    @import url('https://fonts.googleapis.com/css2?family=Roboto&family=Squada+One&display=swap');
    @import url('https://fonts.googleapis.com/css2?family=Work+Sans:wght@200;400&display=swap');
    @import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@500&display=swap');
    @import url('https://fonts.googleapis.com/css2?family=Ubuntu:wght@500&display=swap');

    *, ::after, ::before {
        box-sizing: border-box;
    }

    .container {
        width: 100vw;
        height: 100vh;
        margin: 0;
        font-family: 'Roboto', sans-serif;
        overflow: hidden;
        background: radial-gradient(
                circle,
                rgba(10, 7, 23, 0.12648809523809523) 0%,
                rgba(10, 7, 23, 0.4906337535014006) 31%,
                rgba(10, 7, 23, 1) 78%),
        url('https://cdn.discordapp.com/attachments/775414438924779570/776183635342393354/fixe.png') no-repeat;
        background-size: contain;
        background-position: center 300px;
        box-shadow: inset 00px -10px 100px 100px #0a0717;
        background-color: #0a0717;
    }

    #main-center {
        position: relative;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -60%);
        width: 800px;
        background: #f7f7f7;
        height: 500px;
        border-radius: 15px;
        box-shadow: 15px 15px #898989;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
    }

    #form-header {
        width: 35%;
        background: #1E1C26;
        border-radius: 20px 20px 0 0;
        display: flex;
        letter-spacing: 1.2px;
        font-weight: bold;
        color: white;
        text-transform: uppercase;
        text-align: center;
        justify-content: center;
        position: absolute;
        top: -50px;
        padding: 15px 0;
    }

    #container-page1 {
        width: 90%;
        height: 85%;
        display: flex;
        flex-direction: row;
        margin-top: 30px;
    }

    #left-page1 {
        width: 50%;
        height: 100%;
    }

    #skin-gender-selector-container {
        width: 40px;
        height: 100px;
        position: absolute;
        top: 80px;
        color: white;
        left: 289px;
        z-index: 1;
        transform: translateX(-50%);
        border-radius: 8px 8px 0 0;
        text-align: center;
        text-transform: uppercase;
        font-weight: bold;
        letter-spacing: 1.5px;
    }

    #skin-gender-selector-container button {
        width: 35px;
        height: 35px;
        border-radius: 10px;
        margin: 1px;
        background: #1E1C26;
        color: white;
        outline: none;
        border: 0;
        transition: all 0.2s;
    }

    #skin-gender-selector-container button:hover {
        background: #24222d;
    }

    .gender-active {
        filter: brightness(0) invert(1);
    }

    .gender-nonactive {
        filter: invert(63%) sepia(11%) saturate(7%) hue-rotate(4deg) brightness(91%) contrast(88%);
    }

    #skin-selector-container {
        width: 250px;
        height: 100%;
        padding-bottom: 12px;
        background: #1E1C26;
        border-radius: 15px;
        display: flex;
        justify-content: center;
        position: relative;
        flex-direction: column;
        align-items: center;
    }

    #skin-selector-header {
        width: 130px;
        position: absolute;
        top: -20px;
        background: #1E1C26;
        color: white;
        padding: 5px;
        left: 50%;
        transform: translateX(-50%);
        border-radius: 8px 8px 0 0;
        text-align: center;
        font-weight: bold;
        text-transform: uppercase;
        letter-spacing: 1.5px;
    }

    #skin-gender-selector-container {
        width: 40px;
        height: 100px;
        position: absolute;
        top: 80px;
        color: white;
        left: 289px;
        z-index: 1;
        transform: translateX(-50%);
        border-radius: 8px 8px 0 0;
        text-align: center;
        font-weight: bold;
        text-transform: uppercase;
        letter-spacing: 1.5px;
    }

    #skin-gender-selector-container button {
        width: 35px;
        height: 35px;
        border-radius: 10px;
        margin: 1px;
        background: #1E1C26;
        color: white;
        outline: none;
        border: 0;
        transition: all 0.2s;
    }

    #skin-gender-selector-container button:hover {
        background: #24222d;
    }

    #skin-selector-skin {
        height: 80%;
        margin-top: 20px;
        display: flex;
        justify-content: center;
        background: url('https://cdn.discordapp.com/attachments/775414438924779570/776187008518979614/plateform.png') no-repeat;
        background-size: 120px;
        background-position: center 200px;
        position: relative;
        animation: float 6s ease-in-out infinite;
    }

    .skin-selector-switch {
        height: 100%;
        display: flex;
        justify-content: center;
        align-items: center;
    }

    #skin-selector-preview {
        width: 120px;
        height: 77%;
    }

    .skin-circle-selector {
        width: 40px;
        height: 40px;
        border-radius: 40px;
        background: rgb(255 255 255 / 49%);
        display: flex;
        justify-content: center;
        align-items: center;
        color: #1e1c26;
        font-weight: bold;
        font-size: 20px;
        cursor: pointer;
        user-select: none;
    }

    .gender-selection:hover {
        cursor: pointer;
    }

    .skin-circle-selector:hover {
        background: rgb(255 255 255 / 62%);
        cursor: pointer;
        transition: all 0.2s;
    }

    .button-shop {
        width: 130px;
        height: 30px;
        background: white url('/public/assets/images/form/gold.jpg') no-repeat;
        background-position: -20px -20px;
        border-radius: 10px;
        background-size: 300px;
        justify-content: center;
        color: #1e1c26;
        align-items: center;
        cursor: pointer;
        display: flex;
        text-transform: uppercase;
        font-weight: bolder;
        font-family: 'Work Sans', sans-serif;
        transition: all 0.2s;
    }

    .button-shop:hover {
        color: #1e1c26;
        transition: all 0.2s;
    }

    .gratuit {
        background: #e0e0e0;
        cursor: default;
    }

    .button-shop:hover {
        color: #1e1c26;
        transition: all 0.2s;
    }

    #right-page1 {
        width: 60%;
        height: 100%;
        display: flex;
        flex-direction: column;
        align-items: center;
    }

    #welcome-title {
        padding: 20px 0;
        width: 200px;
        height: 100px;
        text-align: center;
        justify-content: center;
        display: flex;
        text-transform: uppercase;
        flex-direction: column;
        margin-top: 20px;
        color: #1e1c26;
    }

    #welcome-title h1 {
        font-size: 35px;
        font-weight: bolder;
        letter-spacing: 1px;
        margin-bottom: 10px;
    }

    #welcome-title h2 {
        font-size: 14px;
        letter-spacing: 1px;
        font-weight: bold;
        color: #6d6d6d;
        margin: 0 0 30px 0;
    }

    #right-page h1 {
        font-size: 14px;
    }

    #input-pseudo {
        width: 100%;
        height: 50px;
        margin-top: 40px;
        text-align: center;
        justify-content: center;
        display: flex;
        text-transform: uppercase;
        padding: 0 10px;
    }

    #input-pseudo input {
        width: 90%;
        background: #1E1C26;
        border-radius: 15px;
        outline: none;
        border: 0;
        color: white;
        padding: 30px 40px;
        text-align: center;
        text-transform: uppercase;
    }

    #input-pseudo input::placeholder {
        color: #c5c5c5;
    }

    #nav-bar-page1 {
        width: 100%;
        height: 90%;
        display: flex;
        align-items: center;
        justify-content: center;

    }

    #nav-bar-bottom {
        width: 100%;
        height: 50px;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .nav-bar-button {
        margin: 20px;
        padding: 20px;
        width: 200px;
        height: 50px;
        background: #1E1C26;
        outline: outline;
        border: 0;
        border-radius: 10px;
        display: flex;
        align-items: center;
        justify-content: center;
        text-align: center;
        color: white;
        text-transform: uppercase;
        font-weight: bold;
        letter-spacing: 1px;
        font-size: 14px;
        transition: all 0.2s;
    }

    .nav-bar-button:hover {
        background: #36343e;
        cursor: pointer;
    }

    button {
        outline: none;
    }

    #formJoin {
        display: none;
    }

    @keyframes float {
        0% {
            transform: translatey(0px);
        }
        50% {

            transform: translatey(-10px);
        }
        100% {
            transform: translatey(0px);
        }
    }
</style>